package org.springframework.beans.factory.xml.extension;
import org.springframework.beans.factory.config.BeanDefinition;
import org.springframework.beans.factory.config.BeanDefinitionHolder;
import org.springframework.beans.factory.config.PropertyPlaceholderConfigurer;
import org.springframework.beans.factory.support.BeanDefinitionReaderUtils;
import org.springframework.beans.factory.support.RootBeanDefinition;
import org.springframework.beans.factory.xml.BeanDefinitionParser;
import org.springframework.beans.factory.xml.ParserContext;
import org.springframework.core.io.ClassPathResource;
import org.w3c.dom.Element;

public class PropertyPlaceholderConfigureBeanDefinitionParser implements BeanDefinitionParser {
   
   public BeanDefinition parse(Element element, ParserContext parserContext) {
      
      RootBeanDefinition beanDef = new RootBeanDefinition();
      beanDef.setBeanClass(PropertyPlaceholderConfigurer.class);      

      String location = element.getAttribute("location");
      beanDef.getPropertyValues().addPropertyValue("location", new ClassPathResource(location));
      
      String id = element.getAttribute("id");
      
      BeanDefinitionHolder holder = new BeanDefinitionHolder(beanDef, id);
      
      BeanDefinitionReaderUtils.registerBeanDefinition(holder, parserContext.getRegistry());
      
      return beanDef;
   }
}
