package property;

import javax.sql.DataSource;

import junit.framework.TestCase;

import org.hsqldb.Server;
import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

public class JdbcPropertyConfigurerTest extends TestCase {
    private DataSource ds;

    private Server server;

    @Override
    protected void setUp() throws Exception {
        server = new Server();
        server.setDatabaseName(0, "customschema");
        server.setDatabasePath(0,"mem:customschema;sql.enforce_strict_size=true");
        server.setLogWriter(null);
        server.setErrWriter(null);
        server.start();
        super.setUp();
    }

    @Override
    protected void tearDown() throws Exception {
        server.stop();
        server = null;
        super.tearDown();
    }

    public void testGetConnection_org() throws Exception {
        ApplicationContext context = new ClassPathXmlApplicationContext("jdbcproptest-org.xml");
        ds = (DataSource) context.getBean("dataSource");
        assertNotNull(ds.getConnection());
    }
    
    public void testGetConnection_custom() throws Exception {
        ApplicationContext context = new ClassPathXmlApplicationContext("jdbcproptest-custom.xml");
        ds = (DataSource) context.getBean("dataSource");
        assertNotNull(ds.getConnection());
    }
    
}
