package property;
import junit.framework.TestCase;

import org.springframework.beans.factory.config.PropertyPlaceholderConfigurer;
import org.springframework.beans.factory.xml.XmlBeanFactory;
import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;
import org.springframework.core.io.ClassPathResource;


public class PropertyConfigurerTest extends TestCase {

    public void testPropertyConfigurer() throws Exception {
        
        ApplicationContext factory = new ClassPathXmlApplicationContext("proptest.xml");
        TestBean bean = (TestBean)factory.getBean("test");
        assertEquals("Taro", bean.getName());
    }
    
    public void testPropertyConfigurerWithBeanFactory() throws Exception {
        XmlBeanFactory factory = new XmlBeanFactory(new ClassPathResource("proptest.xml"));
        PropertyPlaceholderConfigurer pfc = (PropertyPlaceholderConfigurer) factory.getBean("propertyConfigurer");
        pfc.postProcessBeanFactory(factory);
        TestBean bean = (TestBean)factory.getBean("test");
        assertEquals("Taro", bean.getName());
    
    }
    
}
